v17tx.h File Reference

Go to the source code of this file.

## Typedefs

typedef struct v17_tx_state_s | v17_tx_state_t

## Functions

void | v17_tx_power (v17_tx_state_t *s, float power)
| Adjust a V.17 modem transmit context's output power.
v17_tx_state_t * | v17_tx_init (v17_tx_state_t *s, int bit_rate, int tep, get_bit_func_t get_bit, void *user_data)
| Initialise a V.17 modem transmit context.
int | v17_tx_restart (v17_tx_state_t *s, int bit_rate, int tep, int short_train)
| Reinitialise an existing V.17 modem transmit context.
int | v17_tx_release (v17_tx_state_t *s)
| Release a V.17 modem transmit context.
int | v17_tx_free (v17_tx_state_t *s)
| Free a V.17 modem transmit context.
logging_state_t * | v17_tx_get_logging_state (v17_tx_state_t *s)
| Get the logging context associated with a V.17 modem transmit context.
void | v17_tx_set_get_bit (v17_tx_state_t *s, get_bit_func_t get_bit, void *user_data)
| Change the get_bit function associated with a V.17 modem transmit context.
void | v17_tx_set_modem_status_handler (v17_tx_state_t *s, modem_status_func_t handler, void *user_data)
| Change the modem status report function associated with a V.17 modem transmit context.
| SPAN_DECLARE_NONSTD (int) v17_tx(v17_tx_state_t *s
| Generate a block of V.17 modem audio samples.

## Variables

int16_t | amp []
int16_t int | len

## Typedef Documentation

## v17_tx_state_t

typedef struct v17_tx_state_s v17_tx_state_t

V.17 modem transmit side descriptor. This defines the working state for a single instance of a V.17 modem transmitter.

## Function Documentation

## SPAN_DECLARE_NONSTD()

SPAN_DECLARE_NONSTD | ( | int |  | ) |

Generate a block of V.17 modem audio samples.

Get the next bit of data from a T.38 rate adapting non-ECM buffer context.

Get a bit of received non-ECM image data.

Get the next bit of a transmitted serial bit stream.

Generate a block of V.17 modem audio samples.

Parameters

  s | The modem context.
  amp | The audio sample buffer.
  len | The number of samples to be generated.

Returns
  The number of samples actually generated.

## v17_tx_free()

int v17_tx_free | ( | v17_tx_state_t * | s | ) |

Free a V.17 modem transmit context.

Free a V.17 modem transmit context.

Parameters

  s | The modem context.

Returns
  0 for OK

## v17_tx_get_logging_state()

logging_state_t * v17_tx_get_logging_state | ( | v17_tx_state_t * | s | ) |

Get the logging context associated with a V.17 modem transmit context.

Get the logging context associated with a V.17 modem transmit context.

Parameters

  s | The modem context.

Returns
  A pointer to the logging context

References v17_tx_state_s::logging.

## v17_tx_init()

v17_tx_state_t * v17_tx_init | ( | v17_tx_state_t * | s,
|  | int | bit_rate,
|  | int | tep,
|  | get_bit_func_t | get_bit,
|  | void * | user_data )

Initialise a V.17 modem transmit context.

Initialise a V.17 modem transmit context. This must be called before the first use of the context, to initialise its contents.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 7200, 9600, 12000 and 14400.
  tep | TRUE is the optional TEP tone is to be transmitted.
  get_bit | The callback routine used to get the data to be transmitted.
  user_data | An opaque pointer.

Returns
  A pointer to the modem context, or NULL if there was a problem.

References CARRIER_NOMINAL_FREQ, v17_tx_state_s::carrier_phase_rate, dds_phase_ratef(), v17_tx_state_s::get_bit, v17_tx_state_s::get_bit_user_data, v17_tx_state_s::logging, v17_tx_power(), and v17_tx_restart().

## v17_tx_power()

void v17_tx_power | ( | v17_tx_state_t * | s,
|  | float | power )

Adjust a V.17 modem transmit context's output power.

Adjust a V.17 modem transmit context's power output.

Parameters

  s | The modem context.
  power | The power level, in dBm0

References v17_tx_state_s::gain.

Referenced by v17_tx_init().

## v17_tx_release()

int v17_tx_release | ( | v17_tx_state_t * | s | ) |

Release a V.17 modem transmit context.

Release a V.17 modem transmit context.

Parameters

  s | The modem context.

Returns
  0 for OK

## v17_tx_restart()

int v17_tx_restart | ( | v17_tx_state_t * | s,
|  | int | bit_rate,
|  | int | tep,
|  | int | short_train )

Reinitialise an existing V.17 modem transmit context.

Reinitialise an existing V.17 modem transmit context, so it may be reused.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 7200, 9600, 12000 and 14400.
  tep | TRUE is the optional TEP tone is to be transmitted.
  short_train | TRUE if the short training sequence should be used.

Returns
  0 for OK, -1 for parameter error.

References v17_tx_state_s::baud_phase, v17_tx_state_s::bit_rate, v17_tx_state_s::bits_per_symbol, v17_tx_state_s::carrier_phase, v17_tx_state_s::constellation, v17_tx_state_s::constellation_state, v17_tx_state_s::convolution, v17_tx_state_s::current_get_bit, v17_tx_state_s::diff, v17_tx_state_s::in_training, v17_tx_state_s::rrc_filter, v17_tx_state_s::rrc_filter_step, v17_tx_state_s::scramble_reg, v17_tx_state_s::short_train, v17_tx_state_s::training_step, V17_TRAINING_SEG_1, and V17_TRAINING_SEG_TEP_A.

Referenced by v17_tx_init().

## v17_tx_set_get_bit()

void v17_tx_set_get_bit | ( | v17_tx_state_t * | s,
|  | get_bit_func_t | get_bit,
|  | void * | user_data )

Change the get_bit function associated with a V.17 modem transmit context.

Change the get_bit function associated with a V.17 modem transmit context.

Parameters

  s | The modem context.
  get_bit | The callback routine used to get the data to be transmitted.
  user_data | An opaque pointer.

References v17_tx_state_s::current_get_bit, v17_tx_state_s::get_bit, and v17_tx_state_s::get_bit_user_data.

## v17_tx_set_modem_status_handler()

void v17_tx_set_modem_status_handler | ( | v17_tx_state_t * | s,
|  | modem_status_func_t | handler,
|  | void * | user_data )

Change the modem status report function associated with a V.17 modem transmit context.

Change the modem status report function associated with a V.17 modem transmit context.

Parameters

  s | The modem context.
  handler | The callback routine used to report modem status changes.
  user_data | An opaque pointer.

References v17_tx_state_s::status_handler, and v17_tx_state_s::status_user_data.